The LuaTeX package 'lua-visual-debug' shows boxes, glues, kerns and
penalties in the PDF output.

Usage:

LaTeX:

\usepackage{lua-visual-debug}

or (plain)

\input lua-visual-debug.sty



Requirements: The package has only been tested with LuaTeX and
  the formats plain and LaTeX. Other formats might work as well,
  but other engines only show a warning message.


Copyright 2012 Patrick Gundlach (patrick@gundla.ch)
Public repository: https://github.com/pgundlach/lvdebug
Licensed under the MIT license. See the Lua file for details.
The idea is heavily inspired by Hans Hagen's http://pragma-ade.com/articles/art-visi.pdf

